/*
*  BrokeChnDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "BrokeChnDlgs.h"
#include "Mixmaster.h"
#include "HeadMan.h"
#include "HelpDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TBrokeChnDlg *BrokeChnDlg;
//---------------------------------------------------------------------------
bool __fastcall CheckBrokenChainDialog(TForm *Owner, AnsiString &Text)
{
   BrokeChnDlg = new TBrokeChnDlg(Owner);
   BrokeChnDlg->Msg->Lines->Text = Text;
   BrokeChnDlg->ShowModal();
   bool yes = BrokeChnDlg->ModalResult==mrYes;
   delete BrokeChnDlg;
   return yes;
}
//---------------------------------------------------------------------------
__fastcall TBrokeChnDlg::TBrokeChnDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);
   MessageBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TBrokeChnDlg::CancelBtnClick(TObject *Sender)
{
   OpenHelp("RemailerChains","Broken Remailer Chains","");
}
//---------------------------------------------------------------------------
bool __fastcall GetBrokenMixChains(TStrings *ToStrings)
{
   ToStrings->Clear();
   bool found = false;
   TStringList *list = new TStringList();

   if (FileExists(mlisttxt))
   {
      list->LoadFromFile(mlisttxt);

      while (list->Count && list->Strings[0].Pos("Broken type-II remailer chains:") != 1)
         list->Delete(0);

      if (list->Count)
      {
         list->Delete(0);
         found = true;
      }

      int pos; while (list->Count && !list->Strings[0].Trim().IsEmpty())
      {
         AnsiString chain = list->Strings[0];
         while ((pos=chain.Pos("("))>0) chain.Delete(pos,1);
         while ((pos=chain.Pos(")"))>0) chain.Delete(pos,1);
         while ((pos=chain.Pos(" "))>0) chain[pos] = ',';
         ToStrings->Add(chain);
         list->Delete(0);
      }
   }

   if (!found > 0 && FileExists(clisttxt))
   {
      list->LoadFromFile(clisttxt);

      while (list->Count && list->Strings[0].Pos("Broken type-II remailer chains:")!=1)
         list->Delete(0);

      if (list->Count) list->Delete(0);
      int pos; while (list->Count && !list->Strings[0].Trim().IsEmpty())
      {
         AnsiString chain = list->Strings[0];
         while ((pos=chain.Pos("("))>0) chain.Delete(pos,1);
         while ((pos=chain.Pos(")"))>0) chain.Delete(pos,1);
         while ((pos=chain.Pos(" "))>0) chain[pos] = ',';
         ToStrings->Add(chain);
         list->Delete(0);
      }
   }

   delete list;

   return ToStrings->Count>0;
}
//---------------------------------------------------------------------------
bool __fastcall HasBrokenMixChain(TForm *Owner, TStrings *msg)
{
   bool has=false;
   TStringList *broken = new TStringList();
   GetBrokenMixChains(broken);
   THeaderManager *hm = new THeaderManager(msg);
   AnsiString rem1,rem2,broke,chaindat = ","+GetToken(0,hm->GetDat("Chain: "),";")+",";
   delete hm;

   TStringList *rems = new TStringList();
   for (int i=0; i<broken->Count; i++)
   {
      broke = broken->Strings[i];
      rem1 = GetToken(0,broke,",").LowerCase();
      rem2 = GetToken(1,broke,",").LowerCase();
      if (rem1 == "*")
      {
         rems->CommaText = chaindat;
         TrimNulls(rems);
         if (rems->IndexOf(rem2)>0 && CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken ")+
            s("link. Mail sent from ANY OTHER remailer, to '"+rem2+"' is likely ")+
            s("to fail to be delivered. Would you like to cancel this send and ")+
            s("reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
      if (rem2=="*")
      {
         rems->CommaText = chaindat;
         TrimNulls(rems);
         int idx=rems->IndexOf(rem1);
         if (idx>=0 && idx<rems->Count-1 && CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken ")+
            s("link. Mail sent from '"+rem1+"' to ANY OTHER remailer will ")+
            s("likely fail to be delivered. Would you like to cancel this ")+
            s("send and reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
      if (rem1!="*" && rem2!="*" && chaindat.Pos(","+broke+",")>0)
      {
         if (CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken link. Mail ")+
            s("sent from '"+rem1+"' to '"+rem2+"' will likely fail to be delivered. ")+
            s("Would you like to cancel this send and reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
   }
   delete rems;
   delete broken;
   return has;
}
//---------------------------------------------------------------------------
/*bool __fastcall HasBrokenMixChainAfterEncrypt(TForm *Owner, AnsiString orgchain,
   TStrings *chains, bool &cancel)
{
   bool has=false;
   AnsiString chaindat,broke;
   TStringList *broken = new TStringList();
   GetBrokenMixChains(broken);

   for (int i=0; i<broken->Count; i++)
   {
      broke = ","+broken->Strings[i].Trim()+",";
      for (int r=0; r<chains->Count; r++)
      {
         chaindat = ","+chains->Strings[r].Trim()+",";
         if (chaindat.Pos(broke)>0)// && orgchain.Pos(broke)==0)
         {
            if (CheckBrokenChainDialog(Owner,
               s("The remailer chain Mixmaster selected for you has a broken link. ")+
               s("Mail sent from '"+GetToken(0,broke,",")+"' to '"+GetToken(1,broke,",")+
               s("' will likely fail to be delivered. I suggest you cancel this ")+
               s("send and start again."))))
            {
               has = true;
               break;
            }
         }
      }
      if (has) break;
   }
   delete broken;
   return has;
}*/
//---------------------------------------------------------------------------

bool __fastcall CheckBrokenChain(AnsiString broken, AnsiString chain, AnsiString &rem1, AnsiString &rem2)
{
   bool isbroke = false;

   rem1 = GetToken(0, broken, ",");
   rem2 = GetToken(1, broken, ",");

   if (rem1 == "*" && rem2 == "*")
      return false;

   TStringList *rems = new TStringList();
   rems->CommaText = chain;

   if (rem1 == "*")
   {
      if (rems->IndexOf(rem2) > 0)
         isbroke = true;

      rem1 = "any remailer";
   }

   if (rem2 == "*")
   {
      int idx = rems->IndexOf(rem1);
      if (idx >= 0 && idx < rems->Count - 1)
         isbroke = true;

      rem2 = "any remailer";
   }

   delete rems;

   if (!isbroke)
   {
      chain = "," + chain + ",";

      if (chain.Pos("," + broken + ",") > 0)
         isbroke = true;
   }

   return isbroke;
}
//---------------------------------------------------------------------------

bool __fastcall HasBrokenMixChainAfterEncrypt(TForm *Owner, TStrings *chains,
   bool &cancel, int tries)
{
   cancel = false;
   bool has = false, quit = false;
   AnsiString chaindat, broke, rem1, rem2;
   TStringList *broken = new TStringList();
   GetBrokenMixChains(broken);

   for (int c = 0; c < chains->Count; c++)
   {
      for (int b = 0; b < broken->Count; b++)
      {
         if (CheckBrokenChain(broken->Strings[b], chains->Strings[c], rem1, rem2))
         {
            has = true;
            if (tries >= BrokeRetries)
            {
               switch(MsgDlg(Owner,
                  s("The remailer chain Mixmaster selected for you has a broken link.   \n") +
                  s("Mail sent from '" + rem1 + "' to '" + rem2 + "' will likely fail ")+
                  s("to be delivered.\n\nShall I have mix encrypt the message again?"),
                  s("Mixmaster Broken Chain"), MB_YESNOCANCEL))
               {
                  case IDCANCEL:
                     cancel = true;
                     break;
                  case IDNO:
                     has = false;
                     quit = true;
                     break;
               }
            }
         }
         if (has || quit) break;
      }
      if (has || quit) break;
   }

   delete broken;
   return has;
}
//---------------------------------------------------------------------------
