/*
*  CpkKeyWins2.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef CpkKeyWins2H
#define CpkKeyWins2H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "KeyringWins.h"
#include "PGPbuffers.h"
//---------------------------------------------------------------------------
class TCpkKey2 : public TCustomKey
{
public:
   __property AnsiString algo   = { read=Algo };
   __property TPGPkey *pgpkey   = { read=PgpKey };

   virtual __fastcall TCpkKey2();
   virtual __fastcall TCpkKey2(TCustomKey *key);
   virtual __fastcall TCpkKey2(TStrings *key, bool Enabled=true);
   virtual __fastcall TCpkKey2(TPGPkey *key);
   virtual __fastcall~TCpkKey2();
private:
   virtual void __fastcall SetEnabled(bool Enabled);
   virtual AnsiString __fastcall Address();
   virtual AnsiString __fastcall KeyId();
   virtual AnsiString __fastcall Name();
   virtual AnsiString __fastcall Algo();
   TPGPkey*__fastcall PgpKey();
};

class TCpkKeyList2 : public TCustomKeyList
{
public:
   virtual __fastcall TCpkKeyList2();
   virtual __fastcall TCpkKeyList2(AnsiString filename);
   virtual __fastcall TCpkKeyList2(TCustomKeyList *keys);
   virtual __fastcall TCpkKeyList2(TCustomKey *key);
   virtual __fastcall TCpkKeyList2(TStrings *keys);
   virtual __fastcall~TCpkKeyList2();
   void __fastcall LoadFromFile(AnsiString filename);
   void __fastcall LoadFromStrings(TStrings *keys);
   void __fastcall SaveToStrings(TStrings *keys);
   void __fastcall SaveToFileBak(AnsiString &docname, int bakcopies);
   AnsiString __fastcall KeyDescription(int atPos);
   int  __fastcall AddKeys(TCustomKeyList *keys);
   int  __fastcall AddKeys(TStrings *keys);
   bool __fastcall AddKey(TCustomKey *key);
   bool __fastcall AddKey(TCpkKey2 *key);
   bool __fastcall AddKey(TPGPkey *key);
   bool __fastcall AddKey(TStrings *key);
   TPGPkey*  __fastcall PgpKey(int atPos);
   TCpkKey2* __fastcall Key(int atPos);
};

class TCpkKeyWin2 : public TCustomKeyWin
{
__published:	// IDE-managed Components
	TMenuItem *rlisttxt1;
	TMenuItem *pubringasc1;
	TExplorerButton *BarrBtn;
	TBevel *Bevel4;
	TMenuItem *PopBarRemailerItem;
        TMenuItem *PopGiveNameItem;
        TMenuItem *PopBarRemailerLastItem;
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall ImportBtnClick(TObject *Sender);
	void __fastcall RemailerDocItemClick(TObject *Sender);
	void __fastcall BarrBtnClick(TObject *Sender);
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall PopupMenu2Popup(TObject *Sender);
	void __fastcall PopupMenuPopup(TObject *Sender);
	void __fastcall PopBarRemailerItemClick(TObject *Sender);
        void __fastcall PopGiveNameItemClick(TObject *Sender);
        void __fastcall PopBarRemailerLastItemClick(TObject *Sender);
        
        
        
        
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
private:	// User declarations
public:		// User declarations
    TStringList *caps;
    TCpkKeyList2 *imports;
	virtual __fastcall TCpkKeyWin2(TComponent* Owner);
	virtual __fastcall TCpkKeyWin2(TComponent* Owner, TCpkKeyList2 *Imports);
    virtual __fastcall~TCpkKeyWin2();
    TCpkKey2* __fastcall NodeKey(int atPos);
    AnsiString __fastcall GetCaps(const AnsiString &remailer);
    void __fastcall AddKeysImport(TCustomKeyList *NewKeys);
    void __fastcall AddDupsImport(TCpkKeyList2 *dupkeys);
    void __fastcall EnableKey(int atPos, bool enable);
    void __fastcall LoadTreeView();
    void __fastcall SaveKeys();
    void __fastcall LoadKeys();
};
//---------------------------------------------------------------------------
extern TCpkKeyWin2 *CpkKeyWin2;
extern TStringList *cpkshorts;
//---------------------------------------------------------------------------
#endif
