/*
*  Cyberpunk.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef CyberpunkH
#define CyberpunkH
//---------------------------------------------------------------------------
bool __fastcall HasCpunk();
AnsiString __fastcall CpkDir();
AnsiString __fastcall CpkPublicRing();
bool __fastcall GetBrokenCpkChains(TStrings *ToStrings);
bool __fastcall HasBrokenCpunkChain(TForm *Owner, TStrings *Msg);
bool __fastcall HasBrokenReplyBlockChain(TForm *Owner, AnsiString chaindat);
int  __fastcall GetRlistRemailerCap(const AnsiString &remailer, const AnsiString &Cap);

class TRListTxt : public TStringList
{
private:
   int flasterror;
   AnsiString flasterrormsg;
public:
   __property bool validdoc            =  { read=ValidDoc };
   __property int lasterror            =  { read=flasterror };
   __property AnsiString lasterrormsg  =  { read=flasterrormsg };

   AnsiString filename;
   __fastcall TRListTxt();
   __fastcall TRListTxt(TStrings *Rlistdoc);
   __fastcall TRListTxt(AnsiString Filename);
   __fastcall~TRListTxt();
   bool __fastcall ismiddleman(AnsiString name);
   AnsiString __fastcall address(AnsiString name);
   AnsiString __fastcall name(AnsiString address);
private:
   bool __fastcall ValidDoc();
};

AnsiString __fastcall CpkKeyDesc(TStrings *key);
bool __fastcall CpkKeyDefinately(TStrings *ascii);
bool __fastcall CpkGetNextKey(AnsiString &keydesc,TStrings *key,TStrings *keys);
AnsiString __fastcall CpkCrtDesc(AnsiString &line);
AnsiString __fastcall CpkPasteFromClipboard();

// constants used for help windows
const AnsiString CyberpunkDocs = "Cyberpunk Online Documents"; // caption
const AnsiString UpdateCpkDocs = "UpdateCpkDocs"; // help section
const AnsiString noCkeyfound = "----------";

bool __fastcall CpkRingLineOk(AnsiString &line);
bool __fastcall CpkListLineOk(AnsiString &line);

class TRemailerDoc : public TStringList
{
public:
   bool OpenDoc,Modified;
   virtual __fastcall TRemailerDoc();
   virtual __fastcall TRemailerDoc(AnsiString Docfile);
};
//---------------------------------------------------------------------------
#endif
