/*
*  MimeDecDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MimeDecDlgs.h"
#include "MimeDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMimeDecDlg *MimeDecDlg;
const int modeUudecode = 1;
const int modeBase64 = 2;
const int modeQuotedPrintable = 3;
//---------------------------------------------------------------------------
__fastcall TMIMEmanager::TMIMEmanager(TForm *Owner, AnsiString &AttachDir,
   TProgressBar *ProgressBar)
{
   progressbar = ProgressBar;
   attachdir = AttachDir;
   owner = Owner;
}
//---------------------------------------------------------------------------
TStringList* __fastcall TMIMEmanager::GetNextPart(AnsiString boundary)
{
   if (boundary.IsEmpty() || !mime->Count) return NULL;
   TStringList *part = new TStringList();
   mime->BeginUpdate();

   int i=-1; while(++i<mime->Count)
   {
      if (mime->Strings[i]=="--"+boundary)
      {
         bool inhead=true;
         ++i; while (i<mime->Count)
         {
            AnsiString more,line = mime->Strings[i];
            while(inhead && i<mime->Count-1 &&
               s(" \t").Pos((more=mime->Strings[i+1]).SubString(1,1))>0)
            {
               line += " "+more.Trim();
               mime->Delete(i+1);
            }
            mime->Delete(i);
            if (line.Trim().IsEmpty()) inhead = false;
            if (line=="--"+boundary || line=="--"+boundary+"--") break;
            part->Add(line);
         }
         break;
      }
   }

   mime->EndUpdate();
   if (!part->Count) { delete part; return NULL; }
   AnsiString line,head;
   while(part->Count)
   {
      line = part->Strings[0].Trim();
      if (line.IsEmpty()) break;
      part->Delete(0);

      if (line[line.Length()]!=';') line += ';';
      head += " "+line;
   }
   part->Insert(0,head.TrimLeft());
   return  part;
}

   output = new TStringList();
   progressbar = Progress;
   attachdir = AttachDir;
   owner = Owner;
}
//---------------------------------------------------------------------------
__fastcall TMIMEmanager::~TMIMEmanager()
{
   delete output;
}
//---------------------------------------------------------------------------
// decode functions
bool __fastcall TMIMEmanager::DecodeMessage(TStrings *Message)
{
   mime = Message;
   MimeDlg2 = new TMimeDlg2(owner);
   contenttype = GetPrimaryContentType();
   ismultipart = contenttype.LowerCase().Pos("multipart")>0;
   boundary = GetPrimaryBoundary();
   mimeversion = GetMIMEversion();
   TrimNulls(mime);

   output->Add("");
   if (!boundary.IsEmpty())
   {
      TStringList *next;
      while((next=GetNextPart(boundary))!=NULL)
      {
         parts->AddObject(boundary,new TMIMEpart(next,Output,MimeDlg2));
      }
   }
   for (int i=0; i<mime->Count; i++)
   {
      AnsiString line=mime->Strings[i].Trim();
      if (line.IsEmpty()) break;
      Output->Insert(i,line);
   }
   delete MimeDlg2;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMIMEmanager::DecodePart(TStrings *Part)
{
   return true;
}
//---------------------------------------------------------------------------
// High-Level Functions
//---------------------------------------------------------------------------
bool __fastcall ProcessUUDecode(TForm *Owner, TStrings *input, AnsiString &filename)
{
   MimeDecDlg = new TMimeDecDlg(Owner);
   bool ok = MimeDecDlg->ProcessUUDecode(input,filename);
   delete MimeDecDlg;
   Snooze(200);
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall ProcessBase64(TForm *Owner, TStrings *input, AnsiString &filename)
{
   MimeDecDlg = new TMimeDecDlg(Owner);
   bool ok = MimeDecDlg->ProcessBase64(input,filename);
   delete MimeDecDlg;
   Snooze(200);
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall ProcessQuotedPrintable(TForm *Owner, TStrings *Input, AnsiString &filename)
{
   filename = GetValidUniqueFilename(filename);
   TStringList *output = new TStringList();
   bool ok = ProcessQuotedPrintable(Owner,Input,output);
   if (ok) output->SaveToFile(filename);
   delete output;
   Snooze(200);
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall ProcessQuotedPrintable(TForm *Owner, TStrings *input, TStrings *output)
{
   Snooze(200);
   MimeDecDlg = new TMimeDecDlg(Owner);
   bool ok = MimeDecDlg->ProcessQuotedPrintable(input,output);
   delete MimeDecDlg;
   return ok;
}*/
//---------------------------------------------------------------------------
// TMimeDecDlg
//---------------------------------------------------------------------------
__fastcall TMimeDecDlg::TMimeDecDlg(TComponent* Owner)
	: TForm(Owner)
{
   ProgressBar->Position = 0;
   CenterDialog(this,Owner);
   cancel = false;
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::CancelBtnClick(TObject *Sender)
{
   cancel = true;
}
//---------------------------------------------------------------------------
void __fastcall TMimeDecDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   AnsiString tempname; FILE *in,*out;
   switch (mode)
   {
      case modeUudecode:
         Snooze(300);
         while (input->Strings[0].Pos("begin ")!=1) input->Delete(0);
         if (input->Count) input->Delete(0);
         if (FileExists(filename)) DeleteFile(filename.c_str());
         tempname = GetTempFilename();
         input->SaveToFile(tempname);
         in  = fopen(tempname.c_str(),"r");
         out = fopen(filename.c_str(),"wb");
         ok=uudecode(in,out);
         fclose(out);
         fclose(in);
         if (!ok && FileExists(filename)) DeleteFile(filename.c_str());
         if (FileExists(tempname)) DeleteFile(tempname.c_str());
         ModalResult = ok?mrOk:mrCancel;
         Snooze(300);
         break;
      case modeBase64:
         Snooze(300);
         if (FileExists(filename)) DeleteFile(filename.c_str());
         ok = base64decode(input->Text.c_str(),filename);
         if (!ok && FileExists(filename)) DeleteFile(filename.c_str());
         if (FileExists(tempname)) DeleteFile(tempname.c_str());
         ModalResult = ok?mrOk:mrCancel;
         Snooze(300);
         break;
      case modeQuotedPrintable:
         Snooze(300);
         ok = quotedprintabledecode(input->Text.c_str(),output);
         //ok = quotedprintabledecode(input,output);
         input->Clear();
         ModalResult = ok?mrOk:mrCancel;
         Snooze(300);
         break;
   }
}
//---------------------------------------------------------------------------
// QuotedPrintable
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::ProcessQuotedPrintable(TStrings *Input, TStrings *Output)
{
   Caption = "Quoted-printable decoding...";
   input = Input; output = Output;
   mode = modeQuotedPrintable;
   ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
int __fastcall HexConv(char Ch)
{
   if (s("0123456789").Pos(Ch)>0) return (byte)Ch-(byte)'\0';
   return ((byte)Ch & 15) + 9;
}
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::quotedprintabledecode(TStrings *Input, TStrings *output)
{
   if (!Input || !Input->Count) return false;
output->Clear();
   char *input = new char[Input->Strings[0].Length()+64];
   for (int i=0; i<Input->Count; i++)
   {
      strcpy(input,Input->Strings[i].c_str());
      int Code,SourceIndex=0,DecodedIndex=0,Len=strlen(input);
      char Ch,OldCh;//=0;
   while(true)
   {
      ProgressBar->Position = ((double)SourceIndex/Len)*100;
      if (cancel) return false;

      Ch = input[SourceIndex];
      if (Ch==0)
      {
         input[DecodedIndex] = '\r'; DecodedIndex++;
         input[DecodedIndex] = '\n'; DecodedIndex++;
         break;
      }
      if (Ch!='=')
      {
         input[DecodedIndex++] = Ch;
         SourceIndex++;
      }
      else
      {
         Ch = input[++SourceIndex];
         if (Ch!=0)
         {
            Code = HexConv(Ch);
            Ch = input[++SourceIndex];
            if (Ch!=0)
            {
               Code = (Code << 4) + HexConv(Ch);
               SourceIndex++;
            }
            input[DecodedIndex++] = (char)Code;
         }
         else
         {
            break;
         };
      }
   }
   OldCh = input[DecodedIndex];
   input[DecodedIndex] = 0;

   if (OldCh!=0)
       input[DecodedIndex] = OldCh;
   output->Add(input);
}
   //output->SetText(input);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::quotedprintabledecode(char *input, TStrings *output)
{
   if (!input) return false;
   int Code,SourceIndex=0,DecodedIndex=0,Len=strlen(input);
   char Ch,OldCh;//=0;
   while(true)
   {
      ProgressBar->Position = ((double)SourceIndex/Len)*100;
      if (cancel) return false;

      Ch = input[SourceIndex];
      if (Ch==0)
      {
         input[DecodedIndex] = '\r'; DecodedIndex++;
         input[DecodedIndex] = '\n'; DecodedIndex++;
         break;
      }
      if (Ch!='=')
      {
         input[DecodedIndex++] = Ch;
         SourceIndex++;
      }
      else
      {
         Ch = input[++SourceIndex];
         if (Ch!=0)
         {
            Code = HexConv(Ch);
            Ch = input[++SourceIndex];
            if (Ch!=0)
            {
               Code = (Code << 4) + HexConv(Ch);
               SourceIndex++;
            }
            input[DecodedIndex++] = (char)Code;
         }
         else
         {
            break;
         };
      }
   }
   OldCh = input[DecodedIndex];
   input[DecodedIndex] = 0;

   if (OldCh!=0)
       input[DecodedIndex] = OldCh;
   output->SetText(input);
   return true;
}
//---------------------------------------------------------------------------
/*bool __fastcall TMimeDecDlg::quotedprintabledecode(char *input, TStrings *output)
{ // works with charset="iso-8859-1" !
   if (!input) return false;
   int Code,SourceIndex=0,DecodedIndex=0;
   double Len = strlen(input);
   char Ch,OldCh=0;

   while(SourceIndex<=Len)
   {
      ProgressBar->Position = ((double)SourceIndex/Len)*100;
      if (cancel) return false;

      Ch = input[SourceIndex];
      if (Ch==0)
      {
         input[DecodedIndex++] = '\r';
         input[DecodedIndex++] = '\n';
         break;
      }
      if (Ch!='=')
      {
         input[DecodedIndex++] = Ch;
         SourceIndex++;
      }
      else
      {
         Ch = input[++SourceIndex];
         if (Ch!=0)
         {
            Code = HexConv(Ch);
            Ch = input[++SourceIndex];
            if (Ch!=0)
            {
               Code = (Code << 4) + HexConv(Ch);
               SourceIndex++;
            }
            input[DecodedIndex++] = (char)Code;
         }
         else
         {
            break;
         }
      }
      OldCh = input[DecodedIndex];
      //input[DecodedIndex] = 0;
   }

   if (OldCh!=0) input[DecodedIndex] = OldCh;
   input[DecodedIndex+1] = 0;
   output->SetText(input);
   return true;
}*/
//---------------------------------------------------------------------------
// Base64
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::ProcessBase64(TStrings *Input, AnsiString &Filename)
{
   input = Input;
   Caption = "Base64 decoding...";
   filename = Filename = GetValidUniqueFilename(Filename);
   mode = modeBase64;
   ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::base64decode(char *Input, AnsiString &Filename)
{
   bool flignore,flendtext=false;
   byte ch,inbuf[3],outbuf[4];
   unsigned lentext,ixtext=0;
   short ixinbuf;

   ProgressBar->Position = 0;
   TFileStream *output = new TFileStream(Filename,fmCreate);
   lentext = strlen(Input);
   ixinbuf = 0;
   while(ixtext<lentext)
   {
      //if (ixtext>=lentext) break;
      ProgressBar->Position = ((double)ixtext/(double)lentext)*100;
      if (cancel) return false;

      ch = Input[ixtext++];
      flignore = false;

      if ((ch >= 'A') && (ch <= 'Z')) ch = (byte)(ch - 'A'); else
      if ((ch >= 'a') && (ch <= 'z')) ch = (byte)(ch - 'a' + 26); else
      if ((ch >= '0') && (ch <= '9')) ch = (byte)(ch - '0' + 52); else
      if ( ch == '+') ch = 62; else
      if ( ch == '=') flendtext = true; else
      if ( ch == '/') ch = 63; else
         flignore = true;

      if (!flignore)
      {
         short charsinbuf = 3;
         boolean flbreak = false;
         if (flendtext)
         {
            if (ixinbuf==0) break;

            if ((ixinbuf==1) || (ixinbuf==2)) charsinbuf = 1;
            else charsinbuf = 2;

            flbreak = true;
            ixinbuf = 3;
         }

         inbuf[ixinbuf++] = ch;
         if (ixinbuf==4)
         {
            ixinbuf = 0;
            outbuf[0] = (byte)((inbuf[0] << 2) | ((inbuf[1] & 0x30) >> 4));
            outbuf[1] = (byte)(((inbuf[1] & 0x0F) << 4) | ((inbuf[2] & 0x3C) >> 2));
            outbuf[2] = (byte)(((inbuf[2] & 0x03) << 6) | ( inbuf[3] & 0x3F));
            output->WriteBuffer(outbuf,charsinbuf);
         }
         if (flbreak) break;
      }
   }
   delete output;
   return true;
}
//---------------------------------------------------------------------------
// UUDecode
//---------------------------------------------------------------------------
bool __fastcall TMimeDecDlg::ProcessUUDecode(TStrings *Input, AnsiString &Filename)
{
   input = Input;
   Caption = "UU decoding...";
   filename = Filename = GetValidUniqueFilename(Filename);
   mode = modeUudecode;
   ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
#define DEC(c)	(((c) - ' ') & 077) // single character decode
bool __fastcall TMimeDecDlg::uudecode(FILE *in, FILE *out)
{
    int n,c1,c2,c3;
	char buf[80],*bp;
    double bytesread=0,bytestotal=input->Text.Length();
    ProgressBar->Position = 0;
	while(true)
    {
		if (fgets(buf, sizeof(buf), in) == NULL)
        {
			BingBox((TForm*)Owner,"Attachment: "+filename+" is corrupt! Skipping...",
               "Corrupt Attachment",MB_OK);
            return false;
		}

        ProgressBar->Position = ((bytesread+=sizeof(buf))/bytestotal)*100;
        if (cancel) return false;

		n = DEC(buf[0]); if (n<=0) break;
		bp = &buf[1];
		while (n > 0)
        {
           c1 = ((DEC(bp[0]) << 2) | (DEC(bp[1]) >> 4));
           c2 = ((DEC(bp[1]) << 4) | (DEC(bp[2]) >> 2));
           c3 = ((DEC(bp[2]) << 6) |  DEC(bp[3]));
           if (n>=1) putc((char)c1, out);
           if (n>=2) putc((char)c2, out);
           if (n>=3) putc((char)c3, out);
		   bp += 4;
		   n -= 3;
		}
	}
    return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetValidUniqueFilename(AnsiString &filename)
{
   AnsiString ext,xstr,path=ExtractFilePath(filename),name=ExtractFileName(filename);
   // correct name only, valid path provided by QS
   for (int i=1; i<=name.Length(); i++)
      if (s("\/:*?\"<>|").Pos(name[i])>0) name[i] = '_';
   // parse ext and name without ext
   ext = ExtractFileExt(name);
   name = name.SubString(1,name.Length()-ext.Length());
   int x=0; while(FileExists(path+name+xstr+ext)) xstr = s(++x);
   return path+name+xstr+ext;
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall dropquotes(AnsiString line)
{
   int f=1,l=line.Length();
   if (l<3) return "";

   if (line[f]=='\"') { f++; l-=2; }
   if (line[l]=='\"') l--;
   return line.SubString(f,l);
}*/
//---------------------------------------------------------------------------
