/*
*  MimeDecDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef MimeDecDlgsH
#define MimeDecDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include "global.h"
//---------------------------------------------------------------------------
class TMIMEpart2;
class TMimeDecDlg;

class TMIMEmanager : public TObject
{
public:
   bool ok;
   int lasterror;
   TStringList *Parts;
   AnsiString attachdir;
   TForm *Owner; TMimeDecDlg *mimedlg, TProgressBar *probar;

   __fastcall TMIMEmanager(TForm *Owner, AnsiString &AttachDir, TProgressBar *ProBar);
   __fastcall~TMIMEmanager();
   // decode functions
   bool __fastcall DecodeMessage(TStrings *Message);
   bool __fastcall DecodePart(TStrings *Part);
   bool __fastcall DecodePartQuotedPrintable(TStrings *Part);
   bool __fastcall DecodePartBase64(TStrings *Part);
   bool __fastcall DecodePartUU(TStrings *Part);
   // encode functions
   bool __fastcall EncodeMessage(TStrings *Message);
   bool __fastcall EncodeMessageInline(TStrings *Message);
   bool __fastcall EncodeMessageMultiPart(TStrings *Message);
   bool __fastcall EncodePart(TStrings *Part);
   bool __fastcall EncodePartUU(TStrings *Part);
   bool __fastcall EncodePartBase64(TStrings *Part);
   bool __fastcall EncodePartQuotedPrintable(TStrings *Part);
   bool __fastcall IsMultiPart();
   bool __fastcall IsInline();
   // utility functions
   TMIMEpart2*__fastcall Part(int index);
   AnsiString __fastcall GetValidUniqueFilename(AnsiString &Filename);
   bool __fastcall GetNextPart(TStrings *Part, TStrings *Message);
   void __fastcall SaveToFile(AnsiString &Filename);
private:
   // low-level decode functions
   bool __fastcall decodequotedprintable(char *input, TStrings *output);
   bool __fastcall decodebase64(char *input, AnsiString &Filename);
   bool __fastcall decodeuu(char *input, AnsiString &Filename);
};

class TMIMEpart2 : public TStringList
{
public:
   TStrings *parts;
   AnsiString header;
   __fastcall TMIMEpart2(TStrings *Parts, TStrings *Part);
   __fastcall~TMIMEpart2();
private:
   TStringList* __fastcall GetNextPart(AnsiString Boundary);
   //AnsiString __fastcall GetHeaderSingleLine();
};

//bool __fastcall ProcessBase64(TForm *Owner, TStrings *input, AnsiString &filename);
//bool __fastcall ProcessUUDecode(TForm *Owner, TStrings *input, AnsiString &filename);
//bool __fastcall ProcessQuotedPrintable(TForm *Owner, TStrings *input, AnsiString &filename);
//bool __fastcall ProcessQuotedPrintable(TForm *Owner, TStrings *input, TStrings *output);


class TMimeDecDlg : public TForm
{
__published:	// IDE-managed Components
	TLabel *Label2;
	TProgressBar *ProgressBar;
	TButton *CancelBtn;
	TTimer *Timer1;
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall CancelBtnClick(TObject *Sender);
private:	// User declarations
    bool __fastcall quotedprintabledecode(char *input, TStrings *output);
    bool __fastcall quotedprintabledecode(TStrings *Input, TStrings *output);
    bool __fastcall base64decode(char *input, AnsiString &Filename);
    bool __fastcall uudecode(FILE *in, FILE *out);
public:		// User declarations
    int mode;
    bool ok,cancel;
    AnsiString filename;
    TStrings *input,*output;
	__fastcall TMimeDecDlg(TComponent* Owner);
    //AnsiString __fastcall GetValidUniqueFilename(AnsiString &filename);
    bool __fastcall ProcessUUDecode(TStrings *input, AnsiString &filename);
    bool __fastcall ProcessBase64(TStrings *input, AnsiString &filename);
    bool __fastcall ProcessQuotedPrintable(TStrings *input, TStrings *output);
};

AnsiString __fastcall GetValidUniqueFilename(AnsiString &filename);
AnsiString __fastcall dropquotes(AnsiString line);
//---------------------------------------------------------------------------
const AnsiString attachdir = AppDir+"attachments";
extern TMimeDecDlg *MimeDecDlg;
//---------------------------------------------------------------------------
#endif
