/*
*  MixMsg.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\ComCtrls.hpp>
#include <filectrl.hpp>
#pragma hdrstop

#include "MixMsg.h"
#include "mixmaster.h"
#include "BrokeChnDlgs.h"
#include "MixDupChnDlgs.h"
#include "MsgTooBigDlgs.h"
#include "pgp.h"
#include "global.h"
#include "headman.h"
#include "wipedlgs.h"
#include "console.h"
#include "QSver.h"
#include "fileman.h"
#include "view.h"
#define DISPLAY(msg) display->Add(msg)
//---------------------------------------------------------------------------

void __fastcall MixPoolDeleteFile()
{
   if (FileExists(AppMixPool) && simplewipe(AppMixPool) == WIPE_OK) // wipe the QS mixpool
      DeleteFile(AppMixPool.c_str());
}
//---------------------------------------------------------------------------

void __fastcall MixPoolDelete(int atPos)
{
   TStringList *pool = new TStringList();
   TStringList *message = new TStringList();
   GetAppData(pool,MixPoolKey,AppMixPool);  // get list of messages in pool

   if (pool->Count>atPos)
      PutAppData(MixPoolKey+PS+pool->Strings[atPos],NULL,AppMixPool); // delete from pool

   if (!MixPoolCount())
      MixPoolDeleteFile();

   delete message;
   delete pool;
}
//---------------------------------------------------------------------------

long __fastcall MixPoolGet(TStrings *Message, AnsiString &Name, int atPos)
{
   Name = "";
   Message->Clear();
   TStringList *pool = new TStringList();
   GetAppData(pool,MixPoolKey,AppMixPool);  // get list of messages in pool
   if (pool->Count>atPos)
   {
      Name = pool->Strings[atPos];
      GetAppData(Message,MixPoolKey+PS+Name,AppMixPool); // get first message
   }
   delete pool;
   return atPos;
}
//---------------------------------------------------------------------------

long __fastcall MixPoolAdd(TStrings *Message, AnsiString &Name)
{
   int msgs;
   TStringList *pool = new TStringList();
   PutAppData(MixPoolKey+PS+Name,Message,AppMixPool);
   GetAppData(pool,MixPoolKey,AppMixPool);  // get list of messages in pool
   msgs = pool->Count;
   delete pool;
   return msgs;
}
//---------------------------------------------------------------------------

long __fastcall MixPoolCount()
{
   int count=0;
   if (FileExists(AppMixPool))
   {
      TStringList *pool = new TStringList();
      GetAppData(pool,MixPoolKey,AppMixPool);
      count = pool->Count;
      delete pool;
   }
   return count;
}
//---------------------------------------------------------------------------

void __fastcall MixmasterPoolClear()
{
//sm("ok1");
   AnsiString file,mixpool=MixDir()+"pool\\";
   if (!DirectoryExists(mixpool)) return;

   TStringList *files = new TStringList();
   GetFilenames(files,mixpool+"*.*");
   for (int i=0; i<files->Count; i++)
   {
      file = files->Strings[i];
      if (file==AppMixPool) MixPoolDeleteFile();
      else DeleteFile(file.c_str());
   }
   delete files;
   //RemoveDirectory(mixpool.c_str());
//sm("ok2");
}
//---------------------------------------------------------------------------

__fastcall TMixMessage::TMixMessage(TForm *owner, TStringList *message, TStrings *aDisplay,
   TProgressBar *progressbar, TStringList *theFeedback)
{
   Owner = owner;
   Finished = false;
   Cancelled = false;
   Message = message;
   display = aDisplay;

   HeadMan = new THeaderManager(Message);
   From = HeadMan->Get("From: "); HeadMan->Delete("From: ");
   Host = HeadMan->Get("Host: "); HeadMan->Delete("Host: ");
   AnsiString tmpc = HeadMan->GetDat("Chain: ",Message);
   if (tmpc.SubString(tmpc.Length(),1)==";") tmpc.Delete(tmpc.Length(),1);
   HeadMan->Delete("Chain: ");
   HeadMan->Delete("Fcc: ");

   Copies = GetParam(1,tmpc,"=").Trim().ToIntDef(1); if (Copies==0) Copies++;
   Chain = GetParam(0,tmpc,";").Trim(); tmpc = GetParam(1,tmpc,";").Trim();
   ProgressBar = progressbar;
   Feedback = theFeedback;
   MixmasterPoolClear();
}
//---------------------------------------------------------------------------

__fastcall TMixMessage::~TMixMessage()
{
   MixmasterPoolClear();
   delete HeadMan;
}

//---------------------------------------------------------------------------

AnsiString __fastcall TwoDigits(int val)
{
   AnsiString str = IntToStr(val);
   if (str.Length() < 2)
      str = "0" + str;

   return str;
}
//---------------------------------------------------------------------------

AnsiString __fastcall Rfc822DateTime(TDateTime date)
{
   const AnsiString mths = "JanFebMarAprMayJunJulAugSepOctNovDec";
   const AnsiString days = "SunMonTueWedThuFriSat";
   unsigned short y, m, d, h, n, s, ms;
   date.DecodeTime(&h, &n, &s, &ms);
   date.DecodeDate(&y, &m, &d);

   // ddd, d mmm yyyy hh:mm:ss -0000
   return days.SubString(date.DayOfWeek() * 3 - 2, 3) + ", " +
      IntToStr(d) + " " +
      mths.SubString(m * 3 - 2, 3) + " " +
      IntToStr(y) + " " +
      TwoDigits(h) + ":" +
      TwoDigits(n) + ":" +
      TwoDigits(s) + " ";
      //TimeZoneBias;
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall Rfc822DateTime(TDateTime t)
{
int I;
AnsiString SaveShortDayNames[1..7];
AnsiString SaveShortMonthNames[1..12];
const AnsiString MyShortDayNames[1..7] =
        ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
const AnsiString MyShortMonthNames[1..12] =
        ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug',
         'Sep', 'Oct', 'Nov', 'Dec');

if (ShortDayNames[1] == MyShortDayNames[1])
   return FormatDateTime('ddd, d mmm yyyy hh:mm:ss', t) + ' ' + TimeZoneBias

// We used a localized Delphi version, the day and month names are no
// more english names ! We need to save and replace them
for (i = 1; i <= 7; i++)
{
   SaveShortDayNames[i] = ShortDayNames[i];
   ShortDayNames[i] = MyShortDayNames[i];
}

for (i = 1; i <= 12; i++)
{
   SaveShortMonthNames[i] = ShortMonthNames[i];
   ShortMonthNames[i] = MyShortMonthNames[i];
}

AnsiString date = FormatDateTime('ddd, d mmm yyyy hh:mm:ss', t) + ' ' +
   TimeZoneBias;

for (i = 1; i <= 12; i++)
   ShortMonthNames[i] := SaveShortMonthNames[i];

for (i = 1; i <= 7; i++)
   ShortDayNames[i] := SaveShortDayNames[i];

}*/
//---------------------------------------------------------------------------

void __fastcall TMixMessage::MassageHeaders(TStrings *Message, bool &IsPost)
{
   int idx, pos;
   AnsiString hdr, hdl;
   TStringList *headers = new TStringList();
   THeaderManager *headman = new THeaderManager(Message);

   // convert Post header to Newsgroups header
   AnsiString post = headman->GetDat("Post: ");
   IsPost = !post.IsEmpty();
   if (IsPost)
   {
      idx = headman->Delete("Post: ");
      Message->Insert(idx < 0 ? 0 : idx, "Newsgroups: " + post);
   }

   while ((hdr = headman->PopHeader()) != "")
   {
      hdl = hdr.LowerCase();
      if (hdl.Pos("to: ") == 1 || hdl.Pos("cc: ") == 1 || hdl.Pos("bcc: ") == 1)
      {
         while ((pos = hdr.Pos("\r")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\t")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(", ")) > 0) hdr.Delete(pos + 1, 1);

         // remove and add back spaces after To: <---
         pos = hdr.Pos(":");
         while (hdr.Pos(": ") == pos)
            hdr.Delete(pos + 1, 1);
         hdr.Insert(" ", pos + 1);

         // add back space after each comma
         pos = 0; while (++pos <= hdr.Length())
            if (hdr[pos] == ',')
               hdr.Insert(" ", pos + 1);

         // insert To: first in headers
         if (hdl.Pos("to: ") == 1)
         {
            headers->Insert(0, hdr);
         }
         else
         {
            headers->Add(hdr);
         }
         continue;
      }

      if (hdl.Pos("newsgroups: ") == 1)
      {
         while ((pos = hdr.Pos("\r")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\t")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(" " )) > 0) hdr.Delete(pos, 1);

         // insert Newsgroups: first in headers
         hdr.Insert(" ", hdr.Pos(":") + 1);
         if (IsPost)
         {
            headers->Insert(0, hdr);
         }
         else
         {
            headers->Add(hdr);
         }
         continue;
      }

      if (hdl.Pos("references: ") == 1)
      {
         while ((pos = hdr.Pos("\r")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\t")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(" " )) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("><")) > 0) hdr.Insert(" ", pos + 1);

         hdr.Insert(" ", hdr.Pos(":") + 1);
         headers->Add(hdr);
         continue;
      }

      headers->Add(hdr);
   }

   if (headers->Count > 1)
   {
      headers->Insert(1, "");
      headers->Insert(2, "##");
   }

   for (int i = 0; i < headers->Count; i++)
      Message->Insert(i, headers->Strings[i]);

   delete headers;
   delete headman;
}
/*//---------------------------------------------------------------------------

void __fastcall TMixMessage::MassageHeaders(TStrings *Message, bool &IsPost)
{
   int idx, pos;
   AnsiString hdr, hdl;
   TStringList *headers = new TStringList();
   THeaderManager *headman = new THeaderManager(Message);

   // convert Post header to Newsgroups header
   AnsiString post = headman->GetDat("Post: ");
   IsPost = !post.IsEmpty();
   if (IsPost)
   {
      idx = headman->Delete("Post: ");
      Message->Insert(idx < 0 ? 0 : idx, "Newsgroups: " + post);
   }

   // get existence of pastemarks
   bool gotitalready = false;

   if (Message->Strings[0].TrimRight() == "##")
      gotitalready = true;

   if (!gotitalready)
   {
      for (int i = 0; i < Message->Count; i++)
      {
         if (Message->Strings[i].Trim().IsEmpty())
         {
            if (i < Message->Count - 1 && Message->Strings[i + 1].Trim() == "##")
                gotitalready = true;
            break;
         }
         if (Message->Strings[i].Trim() == "##")
         {
            gotitalready = true;
            break;
         }
      }
   }

   // add pastemarks if needed
   if (!gotitalready)
      Message->Insert(0, "##");

view(Message,"before");

   bool haspaste = false;
   while ((hdr = headman->PopHeader()) != "")
   {
      if (hdr == "##")
      {
         headers->Add(hdr);
         haspaste = true;
         continue;
      }

      // don't format headers until haspaste for sure
      if (!haspaste)
      {
         headers->Add(hdr);
         continue;
      }

      hdl = hdr.LowerCase();
      if (hdl.Pos("to: ") == 1 || hdl.Pos("cc: ") == 1 || hdl.Pos("bcc: ") == 1)
      {
         while ((pos = hdr.Pos("\r")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\t")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(", ")) > 0) hdr.Delete(pos + 1, 1);

         // remove and add back spaces after To: <---
         pos = hdr.Pos(":");
         while (hdr.Pos(": ") == pos)
            hdr.Delete(pos + 1, 1);
         hdr.Insert(" ", pos + 1);

         // add back space after each comma
         pos = 0; while (++pos <= hdr.Length())
            if (hdr[pos] == ',')
               hdr.Insert(" ", pos + 1);

         // insert To: first in headers
         if (hdl.Pos("to: ") == 1)
         {
            headers->Insert(0, hdr);
            headers->Insert(1, "");
         }
         else
         {
            headers->Add(hdr);
         }
         continue;
      }

      if (hdl.Pos("newsgroups: ") == 1)
      {
         while ((pos = hdr.Pos("\r")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\t")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(" " )) > 0) hdr.Delete(pos, 1);

         // insert Newsgroups: first in headers
         hdr.Insert(" ", hdr.Pos(":") + 1);
         if (IsPost)
         {
            headers->Insert(0, hdr);
            headers->Insert(1, "");
         }
         else
         {
            headers->Add(hdr);
         }
         continue;
      }

      if (hdl.Pos("references: ") == 1)
      {
         while ((pos = hdr.Pos("\r")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\t")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(" " )) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("><")) > 0) hdr.Insert(" ", pos + 1);

         hdr.Insert(" ", hdr.Pos(":") + 1);
         headers->Add(hdr);
         continue;
      }

      headers->Add(hdr);
   }

   if (Message->Strings[0] == "##")
      Message->Insert(0, "");

   for (int i = 0; i < headers->Count; i++)
      Message->Insert(i, headers->Strings[i]);

view(Message,"after");

   delete headers;
   delete headman;
}*/
//---------------------------------------------------------------------------

bool __fastcall TMixMessage::IsRandomOrMix204(const AnsiString &remailer)
{
   if (remailer == "*") return true;
   return IsMix204(remailer);
}
//---------------------------------------------------------------------------

bool __fastcall TMixMessage::IsMix204(const AnsiString &remailer)
{
   bool m204 = true;
   TStringList *type2 = new TStringList();

   if (FileExists(mtyp2txt))
      type2->LoadFromFile(mtyp2txt);

   for (int i = 0; i < type2->Count; i++)
   {
      AnsiString line = type2->Strings[i];

      if (GetToken(0, line, " ") == remailer)
      {
         if (GetToken(3, line, " ").Pos("2.0.4") != 1)
             m204 = false;

         break;
      }
   }

   delete type2;
   return m204;
}
//---------------------------------------------------------------------------

long __fastcall TMixMessage::MixMessage(TStrings *Message, AnsiString &Chain, int copies,
   TStringList *Feedback)
{
   int ret;
   bool ispost;
   BUFFER *msg = buf_new(); assert(msg != NULL);
   BUFFER *fbk = buf_new(); assert(fbk != NULL);
   msg->sensitive = true; fbk->sensitive = true;
   THeaderManager *headers = new THeaderManager(Message);
   int idx = headers->Delete("Paste-Headers: ");
   if (idx > 0) Message->Insert(idx, "");

   MassageHeaders(Message, ispost);

   for (int i = 0; i < Message->Count; i++)
   {
      AnsiString line = Message->Strings[i]+"\n";
      buf_append(msg,(byte*)line.c_str(),line.Length());
   }

//view((char*)msg->data);
   if ((ret = mix_encrypt((ispost ? MSG_POST : MSG_MAIL), msg, Chain.c_str(), copies, fbk)) == 0)
       mix_send();

   Feedback->Text = AnsiString((char*)fbk->data);
   for (int i = 0; i < Feedback->Count; i++)
      Feedback->Strings[i].Insert(" ", 1);

   delete headers;

   buf_free(msg);
   buf_free(fbk);

   return ret;
}
//---------------------------------------------------------------------------

bool __fastcall StringInList(AnsiString &String, TStringList *List)
{
   bool isin=false;
   for (int i=0; i<List->Count; i++)
   {
      if (List->Strings[i]==String)
      {
         isin = true;
         break;
      }
   }
   return isin;
}

//---------------------------------------------------------------------------

void DeleteStrings(TStrings *FromList, TStrings *ThatAreInList)
{
   int f=0; while (f<FromList->Count)
   {
      int pos = -1;
      for (int i=0; i<ThatAreInList->Count; i++)
      {
         if (FromList->Strings[f]==ThatAreInList->Strings[i])
         {
            pos = f;
            break;
         }
      }
      if (pos>=0)
         FromList->Delete(pos);
      else
         f++;
   }
}
//---------------------------------------------------------------------------

long __fastcall TMixMessage::Execute(int tries)
{
   long ret=0;
   AnsiString file, text, name, curstr;
   if (Cancelled) { Finished = true; return ret; }

   TStringList *prefiles = new TStringList();
   GetFilenames(prefiles,QUEUEFILES);

   TStringList *clrmessage = new TStringList();
   clrmessage->AddStrings(Message);

   DISPLAY("Mixmaster encrypting... ");
   Application->ProcessMessages();

   if ((ret = MixMessage(Message, Chain, Copies, Feedback)) == 0)
   {
      TStringList *msg = new TStringList();
      TStringList *outfiles = new TStringList();
      GetFilenames(outfiles, QUEUEFILES);

      if (ret == 0 && !Cancelled)
      {
         AnsiString S = Feedback->Count == 1 ? "" : "s";
         DISPLAY("Mixmaster reports " + s(Feedback->Count) + " chain" + S + ": ");
         for (int i=0; i<Feedback->Count; i++)
         {
            DISPLAY(Feedback->Strings[i]);
            AppProcessMessages();
         }
         assert(Feedback->Count > 0);

         if (HasBrokenMixChainAfterEncrypt(Owner, Feedback, Cancelled, tries) ||
             HasDuplicateMixChainsAfterEncrypt(Owner, Feedback, Cancelled, tries))
         {
            DeleteStrings(outfiles, prefiles);
            for (int i=0; i<outfiles->Count; i++)
               DeleteFile(outfiles->Strings[i].c_str());
            MixPoolDeleteFile();

            Message->Clear();
            Message->AddStrings(clrmessage);

            if (!Cancelled)
            {
               DISPLAY("");
               DISPLAY("I've encountered a problem with remailer selections, no big deal");
               DISPLAY("starting again...\n");
            }
            else DISPLAY("");

            tries++;

            Execute(tries);
            goto exit;
         }
         else
         {
            DeleteStrings(outfiles, prefiles);

            for (int i=0; i<outfiles->Count; i++)
            {
               file = outfiles->Strings[i];
               if (!Cancelled)
               {
                  curstr = (i + 1 < 10? " " : "") + AnsiString(i + 1);
                  name = MixmasterChain + " " + curstr + " of " + AnsiString(outfiles->Count);
                  msg->LoadFromFile(file); msg->Delete(0);
                  msg->Insert(0, Host);
                  msg->Insert(1, From);
                  msg->SaveToFile(file);
                  MixPoolAdd(msg, name);
               }

               DeleteFile(file.c_str());
            }
         }
      }
      else MixPoolDeleteFile();

   exit:
      delete outfiles;
      delete msg;
   }

   delete clrmessage;
   delete prefiles;

   if (!Cancelled && ret != 0)
   {
      DISPLAY("Mixmaster reports error condition: ");
      for (int i = 0; i < Feedback->Count; i++)
      {
         DISPLAY(Feedback->Strings[i]);
         Application->ProcessMessages();
      }
   }
   Finished = true;
   return ret;
}
//---------------------------------------------------------------------------


