/*
*  OldOpenDlg.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "OldOpenDlg.h"
#include "NewNameDlgs.h"
#include "MsgWins.h"
#include "SaveDlg.h"
#include "Global.h"
#include "FileMan.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOpenForm *OpenForm;
//---------------------------------------------------------------------------
AnsiString __fastcall OpenOpenDlg(TStrings *Message, AnsiString &Section,
   bool SortView)
{
   AnsiString title;
   OpenForm = new TOpenForm(AppMainForm);
   OpenForm->ListView->SortType = SortView ? stText : stNone;
   OpenForm->Init(Section);
   OpenForm->mode = "Open ";
   OpenForm->ShowModal();
   if (OpenForm->ModalResult==mrOk)
   {
      Section = OpenForm->DatSection();
      Message->Clear(); Sleep(SleepTime);
      GetAppData(Message, Section+PS+OpenForm->Name->Text);
      title = OpenForm->Name->Text;
   }
   delete OpenForm;
   return title;
}
//---------------------------------------------------------------------------
__fastcall TOpenForm::TOpenForm(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);//AppMainForm);
   //ListBox->MultiSelect = true;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::Init(AnsiString &Section)
{
   //int width = (ListBox->Width - 4) / ListBox->Columns;
   //SendMessage(ListBox->Handle, LB_SETCOLUMNWIDTH, width, 0);
   //ListBox->Perform(LB_SETCOLUMNWIDTH, 40, 0);

   if (Section != MailQueue && Section != ProblemQueue && Section != SMTPLog &&
       Section != POP3Log && Section != ChainLog && Section != ErrChkLog)
   {
      LookInBox->Items->Add(UserNotes);
      LookInBox->Items->Add(UserMessages);
      LookInBox->Items->Add(UserTemplates);
   }
   //else
   //   ListBox->Columns = 0;

   if (Section!=SMTPLog && Section!=POP3Log && Section!=ChainLog && Section!=ErrChkLog)
   {  // no extra lookinbox items for pop and smtp
      if (AppDataExists(ProblemQueue))
         LookInBox->Items->Add(ProblemQueue);
      if (AppDataExists(MailQueue))
         LookInBox->Items->Add(MailQueue);
   }
   else
   {
      LookInBox->Items->Add(Section);
      //ListBox->Font->Name = "Courier New";
      //ListBox->Font->Size = 9;
   }
   LookInBox->ItemIndex = LookInBox->Items->IndexOf(Section);
   if (Section == MailQueue || Section == ProblemQueue)
      PopRenameItem->Visible = false;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TOpenForm::Title()
{
   if (DatSection()==UserTemplates) return "Template";
   if (DatSection()==UserMessages) return "Draft";
   if (DatSection()==UserNotes) return "Note";
   if (DatSection()==SMTPLog) return SMTPLog;
   if (DatSection()==POP3Log) return POP3Log;
   if (DatSection()==ErrChkLog) return ErrChkLog;
   if (DatSection()==ChainLog) return ChainLog;
   return "";
}
//---------------------------------------------------------------------------

void __fastcall TOpenForm::LoadItems()
{
   Caption = mode+Title();
   TStringList *tmp = new TStringList();
   GetAppData(tmp, DatSection());

   ListView->Items->Clear();
   for (int i = 0; i < tmp->Count; i++)
   {
      TListItem *item = ListView->Items->Add();
      item->Caption = tmp->Strings[i];
   }

   Name->Clear();
   delete tmp;
}
//---------------------------------------------------------------------------

/*void __fastcall TOpenForm::LoadItems()
{
// Name->Clear();
   Caption = mode+Title();
   ListBox->Items->Clear();
   TStringList *tmp = new TStringList();
   GetAppData(ListBox->Items,DatSection());
   ListBox->Items->AddStrings(tmp);
   if (ListBox->Items->Count)
      ListBox->ItemIndex = 0;
   delete tmp;
}*/
//---------------------------------------------------------------------------

void __fastcall TOpenForm::PopupMenuPopup(TObject *Sender)
{
   bool ok = ListView->Selected;
   PopRenameItem->Enabled = ok;
   PopDeleteItems->Enabled = ok;
}
//---------------------------------------------------------------------------

void __fastcall TOpenForm::PopDeleteItemsClick(TObject *Sender)
{
   assert(ListView->Selected != NULL && ListView->Selected->Caption != "");

   if (MsgBoxHwnd(Handle, "Delete '" + ListView->Selected->Caption + "'.  Are you sure?",
          "Delete Message",MB_OKCANCEL) == IDOK)
   {
      PutAppData(DatSection()+PS+ListView->Selected->Caption, NULL);
      ListView->Selected->Delete();

      if (DatSection()==ProblemQueue)
         Application->MainForm->Perform(WM_PROBLEMCHANGE,0,NULL);
      if (DatSection()==MailQueue)
         Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL);

      ActiveControl = Panel3;
      Name->Clear();
   }
}
//---------------------------------------------------------------------------

void __fastcall TOpenForm::PopRenameItemClick(TObject *Sender)
{
   assert(ListView->Selected != NULL && ListView->Selected->Caption != "");

   AnsiString Newname,Oldname;
   Oldname = ListView->Selected->Caption;

   if ((Newname = GetMailboxRename(Oldname)) != "")
   {
      if (Newname == Oldname)
         return;

      Cursor = crHourGlass;
      TStringList *mail = new TStringList();
      GetAppData(mail, DatSection()+PS+Oldname);
      PutAppData(DatSection()+PS+Oldname, NULL);
      PutAppData(DatSection()+PS+Newname, mail);
      delete mail;

      ListView->Selected->Caption = Newname;
      Cursor = crDefault;
   }
}
//---------------------------------------------------------------------------

void __fastcall TOpenForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && Name->Text.Trim().IsEmpty())
   {
      BingBox(this,"You must enter a name or click 'Close'.","Filename Required",MB_OK);
      CanClose = false;
      return;
   }
   // do these before cancel as messages/problems may have been deleted
   if (DatSection()==ProblemQueue) Application->MainForm->Perform(WM_PROBLEMCHANGE,0,NULL); else
   if (DatSection()==MailQueue) Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL); else
   if (ModalResult==mrCancel) return;

   // can't exit ok with empty name
   if (Name->Text.IsEmpty()) {
      //MyBeep(MB_OK);
      //CanClose = false;
      ModalResult = mrCancel;
      return;
   }
   // is the name supplied in the list?
   /*if (ListBox->Items->IndexOf(Name->Text)<0)
   {
      MsgBoxHwnd(Handle,"Invalid Name!\n\nPlease select from the list supplied.","Open Error",MB_OK);
      Name->Clear();
      ActiveControl = Name;
      CanClose = false;
      return;
   }*/

   // is this the master list of data section?
   /*if (DatSection()==UserData)
   {
      AnsiString tmp;
      if (ListBox->ItemIndex>=0)
         tmp = ListBox->Items->Strings[ListBox->ItemIndex];
      LookInBox->ItemIndex = LookInBox->Items->IndexOf(tmp);
      LoadItems();
      CanClose = false;
      return;
   }*/
   // exit ok--no problems
}
//---------------------------------------------------------------------------

void __fastcall TOpenForm::LookInBoxChange(TObject *Sender)
{
   /*if (LookInBox->Text == UserData)
   {// not used currently
      ListBox->Clear();
      Caption = mode+Title();
      if (AppDataExists(ProblemQueue)) ListBox->Items->Add(ProblemQueue);
      if (AppDataExists(MailQueue)) ListBox->Items->Add(MailQueue);
      if (AppDataExists(UserNyms)) ListBox->Items->Add(UserNyms);
      ListBox->Items->Add(UserTemplates);
      ListBox->Items->Add(UserMessages);
      ListBox->Items->Add(UserNotes);
   }
   else*/
      LoadItems();
}
//---------------------------------------------------------------------------

void __fastcall TOpenForm::FormShow(TObject *Sender)
{
   LookInBoxChange(Sender);
   if (DatSection()==SMTPLog || DatSection()==POP3Log)
   {
      //int index = ListBox->Items->Count-5; if (index<0) index = 0;
      ////ListBox->ItemIndex = ListBox->Items->Count-1;
      //ListBox->TopIndex = index;
      //ListBox->PopupMenu = NULL;
   }
}
//---------------------------------------------------------------------------

void __fastcall TOpenForm::ListViewClick(TObject *Sender)
{
   bool ok = ListView->Selected;
   if (ok)
      Name->Text = ListView->Selected->Caption;
   OkBtn->Enabled = ok;
}
//---------------------------------------------------------------------------

void __fastcall TOpenForm::ListViewDblClick(TObject *Sender)
{
   if (ListView->Selected)
      ModalResult = mrOk;
}
//---------------------------------------------------------------------------
