/*
*  PgpKeyWins.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef PgpKeyWinsH
#define PgpKeyWinsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "explbtn.hpp"
#include "pgpbuffers.h"
#include "fileman.h"
#include "global.h"
//---------------------------------------------------------------------------
class TPgpKeyWin : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TBevel *Bevel1;
  TBevel *Bevel2;
  TBevel *Bevel3;
  TTimer *Timer1;
  TTreeView *TreeView;
  TImageList *ImageList1;
  TOfficeButton *OkBtn;
  TOfficeButton *SaveBtn;
  TOfficeButton *RefreshBtn;
  TOfficeButton *ImportBtn;
  TOfficeButton *DisableBtn;
  TOfficeButton *DeleteBtn;
  TOfficeButton *HelpBtn;
  TPopupMenu *PopupMenu;
  TMenuItem *PopSaveItem;
  TMenuItem *PopRefreshItem;
  TMenuItem *PopImportItem;
  TMenuItem *N3;
  TMenuItem *PopDeleteItem;
  TMenuItem *PopDisableItem;
  TMenuItem *N1;
  TOfficeButton *GenKeyBtn;
  TBevel *Bevel4;
  TOfficeButton *ExportBtn;
  TPopupMenu *PopupMenu1;
  TMenuItem *RefreshFromDiskItem;
  TMenuItem *RefreshFromPGP6Item;
  TPopupMenu *PopupMenu2;
  TMenuItem *SaveToDiskItem;
  TMenuItem *SaveToPGP6Item;
  TOfficeButton *SignBtn;
  TMenuItem *N2;
  TMenuItem *CopyDescripItem;
  TMenuItem *PopUserIdItem;
  TMenuItem *PopKeyIdItem;
  TMenuItem *PopDescriptionItem;
  void __fastcall FormResize(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall SaveBtnClick(TObject *Sender);
  void __fastcall DeleteBtnClick(TObject *Sender);
  void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall OkBtnClick(TObject *Sender);
  void __fastcall DisableBtnClick(TObject *Sender);
  void __fastcall TreeViewMouseDown(TObject *Sender, TMouseButton Button,
     TShiftState Shift, int X, int Y);
  void __fastcall ImportBtnClick(TObject *Sender);
  void __fastcall PopupMenuPopup(TObject *Sender);
  void __fastcall GenKeyBtnClick(TObject *Sender);
  void __fastcall HelpBtnClick(TObject *Sender);
  void __fastcall RefreshFromDiskItemClick(TObject *Sender);
  void __fastcall RefreshFromPGP6ItemClick(TObject *Sender);
  void __fastcall PopupMenu1Popup(TObject *Sender);
  void __fastcall PopupMenu2Popup(TObject *Sender);
  void __fastcall SaveToDiskItemClick(TObject *Sender);
  void __fastcall ExportBtnClick(TObject *Sender);
  void __fastcall SignBtnClick(TObject *Sender);
  void __fastcall PopUserIdItemClick(TObject *Sender);
  void __fastcall PopKeyIdItemClick(TObject *Sender);
  void __fastcall PopDescriptionItemClick(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
private:	// User declarations
public:		// User declarations
  int curkey;
  TList *nodes;
  TDateTime lastupdate;
  bool modified,closing;
  TStringList *enables,*deletes;
  TPGPbuffer *pdb,*sdb,*keylist;
  AnsiString pubring,secring,cap;
  virtual __fastcall TPgpKeyWin(TComponent* Owner);
  virtual __fastcall TPgpKeyWin(TComponent* Owner, AnsiString pubringpkr, AnsiString secringskr);
  virtual __fastcall~TPgpKeyWin();
  void __fastcall SetNoSDK();
  void __fastcall GenTreeView(TTreeView *TreeView, TStrings *newkeyids=NULL);
  void __fastcall ClearTreeView();
  AnsiString __fastcall idtext8(int atpos);
  void __fastcall EnableDisableBtn(bool enable);
  bool __fastcall EnableKey(int atPos, bool enable);
  bool __fastcall EnabledKey(int atPos);
  void __fastcall SetCount(bool clear=false);
  void __fastcall SetNothingSelected();
  void __fastcall SetHelpBtnPos();
  bool __fastcall DeleteKey(int atPos);
  bool __fastcall AddKeysImport(TPGPbuffer *newkeys);
  bool __fastcall CheckRefreshFromPGP6();
  bool __fastcall RefreshFromPGP6();
  void __fastcall RefreshAfterPGP6();
  bool __fastcall Refresh();
  bool __fastcall Save();
  // message functions
  void virtual __fastcall WMSaveBtnClicked(TMessage& Msg);
  void virtual __fastcall WMRefreshBtnClicked(TMessage& Msg);
  void virtual __fastcall WMImportBtnClicked(TMessage& Msg);
  void virtual __fastcall WMDisableBtnClicked(TMessage& Msg);
  void virtual __fastcall WMDeleteBtnClicked(TMessage& Msg);
  void virtual __fastcall WMAreYouKeyWindow(TMessage& Msg);
  void virtual __fastcall WMAreYouPgpKeyWindow(TMessage& Msg);
  void virtual __fastcall WMGetKeyringMenuDat(TMessage& Msg);
  void virtual __fastcall WMKeyringNewKeyItemClicked(TMessage& Msg);
  void virtual __fastcall WMDoPGP6Update(TMessage& Msg);
   // message map
  BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM_DOPGP6UPDATE,TMessage,WMDoPGP6Update)
  MESSAGE_HANDLER(WM_SAVEBTNCLICKED,TMessage,WMSaveBtnClicked)
  MESSAGE_HANDLER(WM_REFRESHBTNCLICKED,TMessage,WMRefreshBtnClicked)
  MESSAGE_HANDLER(WM_IMPORTBTNCLICKED,TMessage,WMImportBtnClicked)
  MESSAGE_HANDLER(WM_DISABLEBTNCLICKED,TMessage,WMDisableBtnClicked)
  MESSAGE_HANDLER(WM_DELETEBTNCLICKED,TMessage,WMDeleteBtnClicked)
  MESSAGE_HANDLER(WM_AREYOUKEYWINDOW,TMessage,WMAreYouKeyWindow)
  MESSAGE_HANDLER(WM_AREYOUPGPKEYWINDOW,TMessage,WMAreYouPgpKeyWindow)
  MESSAGE_HANDLER(WM_GETKEYRINGMENUDAT,TMessage,WMGetKeyringMenuDat)
  MESSAGE_HANDLER(WM_KEYRINGNEWKEYITEMCLICKED,TMessage,WMKeyringNewKeyItemClicked)
  END_MESSAGE_MAP(TForm)
};

class TPGPbufferList : public TStringList
{
public:
   virtual __fastcall TPGPbufferList();
   virtual __fastcall~TPGPbufferList();
   virtual void __fastcall Clear();
};

//---------------------------------------------------------------------------
extern TPgpKeyWin *PgpKeyWin;
//---------------------------------------------------------------------------
#endif
