/*
*  RemailerCfgDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "RemailerCfgDlgs.h"
#include "ClipReply.h"
#include "HelpDlgs.h"
#include "msgwins.h"
#include "fileman.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TRemailerCfgDlg *RemailerCfgDlg;
//---------------------------------------------------------------------------

void __fastcall PrepareRemailerConfigRequests(TForm *Owner, TStrings *remailers,
   AnsiString current)
{
   RemailerCfgDlg = new TRemailerCfgDlg(Owner);
   RemailerCfgDlg->RemsBox->Items->AddStrings(remailers);
   RemailerCfgDlg->RemsBox->Text = current;
   RemailerCfgDlg->RemsBoxChange(NULL);
   RemailerCfgDlg->ShowModal();
   delete RemailerCfgDlg;
}

//---------------------------------------------------------------------------

__fastcall TRemailerCfgDlg::TRemailerCfgDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);
   Label2->Caption = "";
}
//---------------------------------------------------------------------------

void __fastcall TRemailerCfgDlg::SomeBoxChange(TObject *Sender)
{
   OkBtn->Enabled = ValidAddress() && ConfigBoxChecked();
}
//---------------------------------------------------------------------------

bool __fastcall TRemailerCfgDlg::ConfigBoxChecked()
{
   return StatsBox->Checked || ConfigBox->Checked || HelpBox->Checked ||
      KeyBox->Checked || AdminBox->Checked;
}
//---------------------------------------------------------------------------

bool __fastcall TRemailerCfgDlg::ValidAddress()
{
   AnsiString dom,addr=RemsBox->Text;
   int pos = addr.Pos("@");
   if (pos>1)
   {
      dom = addr.SubString(pos+1,256);
      if ((pos=dom.Pos("."))>1 && pos<dom.Length())
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------

void __fastcall TRemailerCfgDlg::MakeMessage(TStrings *message, AnsiString &subject)
{
   AnsiString addrs = RemsBox->Text;
   TStringList *msg = new TStringList(); msg->Text = message->Text;
   for (int i=0; i<msg->Count; i++)
   {
      AnsiString tmpstr = msg->Strings[i];
      if (tmpstr.Pos("To:")==1) msg->Strings[i] = "To: "+addrs;
      if (tmpstr.Pos("Subject:")==1) msg->Strings[i] = "Subject: "+subject;
      if (tmpstr.IsEmpty()) break;
   }
   PutMessageOnDesktop(AppMainForm,msg);
   delete msg;
}
//---------------------------------------------------------------------------

void __fastcall TRemailerCfgDlg::MakeMessageNymserverKey(TStrings *message)
{
   AnsiString addrs = GetToken(1, RemsBox->Text, "@");
   TStringList *msg = new TStringList(); msg->Text = message->Text;
   for (int i = 0; i< msg->Count; i++)
   {
      if (msg->Strings[i].Pos("Subject:") == 1)
      {
         msg->Delete(i);
         break;
      }
   }
   for (int i = 0; i< msg->Count; i++)
   {
      AnsiString tmpstr = msg->Strings[i];
      if (tmpstr.Pos("To:")==1) msg->Strings[i] = "To: remailer-key@"+addrs;
      if (tmpstr.Pos("Subject:")==1) msg->Strings[i] = "Subject: none";
      if (tmpstr.IsEmpty()) break;
   }
   PutMessageOnDesktop(AppMainForm,msg);
   delete msg;
}
//---------------------------------------------------------------------------

void __fastcall TRemailerCfgDlg::GenerateConfigMessages()
{
   AnsiString TempName;
   TStringList *temps = new TStringList();
   GetAppData(temps,UserTemplates);
   if (temps->IndexOf("config-request")>=0) TempName = UserTemplates+PS+"config-request";
   if (TempName.IsEmpty()) TempName =
       GetTemplateName("Select Template For Remailer Config-Request",modeMessage);
   if(!TempName.IsEmpty())
   {
//sm(TempName);
      TStringList *Template = new TStringList();
      AnsiString cap = Caption; Caption = "Generating...";
      GetAppData(Template, TempName);
      if (ConfigBox->Checked) MakeMessage(Template,"remailer-config");
      if (KeyBox->Checked)
      {
         AnsiString addrs = RemsBox->Text.LowerCase();
         if (addrs.Pos("config@") != 1 && addrs.Pos("send@") != 1)
         {
            MakeMessage(Template,"remailer-key");
         }
         else
         {
            MakeMessageNymserverKey(Template);
         }
      }
      if (HelpBox->Checked) MakeMessage(Template,"remailer-help");
      if (StatsBox->Checked) MakeMessage(Template,"remailer-stats");
      if (AdminBox->Checked) MakeMessage(Template,"remailer-adminkey");
      AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Config-request(s) created");
      Sleep(200); Caption = cap;
      ModalResult = mrOk;
      delete Template;
   }
}
//---------------------------------------------------------------------------

void __fastcall TRemailerCfgDlg::OkBtnClick(TObject *Sender)
{
   GenerateConfigMessages();
}
//---------------------------------------------------------------------------

void __fastcall TRemailerCfgDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("RemailerConfig","Remailer Config-Request Dialog","");
}
//---------------------------------------------------------------------------

void __fastcall TRemailerCfgDlg::RemsBoxChange(TObject *Sender)
{
   OkBtn->Enabled = false;
   ConfigBox->Checked = false;
   KeyBox->Checked = false;
   AdminBox->Checked = false;
   HelpBox->Checked = false;
   StatsBox->Checked = false;

   AnsiString addrs = RemsBox->Text;
   if (addrs.Pos("send@") == 1 || addrs.Pos("config@") == 1)
   {
      ConfigBox->Enabled = false;
      AdminBox->Enabled = false;
      HelpBox->Enabled = false;
      StatsBox->Enabled = false;
      Label2->Caption = addrs + " is a nymserver. I can only get you a key for it.";
   }
   else
   {
      ConfigBox->Enabled = true;
      AdminBox->Enabled = true;
      HelpBox->Enabled = true;
      StatsBox->Enabled = true;
      Label2->Caption = "";
   }
}
//---------------------------------------------------------------------------
