/*
*  SMTPProxyDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SMTPProxyDlgs.h"
#include "HelpDlgs.h"
#include "Fileman.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TSMTPProxyDlg *SMTPProxyDlg;
//---------------------------------------------------------------------------
bool __fastcall GetWebProxyInfo(TForm *Owner)
{
   SMTPProxyDlg = new TSMTPProxyDlg(Owner);
   bool ok = SMTPProxyDlg->Execute();
   delete SMTPProxyDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TSMTPProxyDlg::TSMTPProxyDlg(TComponent* Owner)
  : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner); Top -= 10;
   ProxyPswdEdit->PasswordChar = '*';
   ProxySocksVer->ItemIndex = 1;
   LoadProxy();
}
//---------------------------------------------------------------------------
void __fastcall TSMTPProxyDlg::HelpBtnClick(TObject *Sender)
{
   //OpenHelp("ProxyHTTP","Proxy Host","");
}
//---------------------------------------------------------------------------
bool __fastcall TSMTPProxyDlg::Execute()
{
   ShowModal();
   if (ModalResult==mrOk &&
      (ProxyHostEdit->Modified || ProxyHostEdit->Modified ||
       ProxyPswdEdit->Modified || ProxyUserEdit->Modified ||
       ProxySocksVer->Text != socksverorg ||
       ProxyTORBox->Checked != proxytororg))
   {
      StoreProxy();
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPProxyDlg::LoadProxy()
{
   TStringList *smtp = new TStringList();
   GetAppData(smtp, "smtpproxy");
   ProxyHostEdit->Text = smtp->Values["ProxyHost"]; ProxyHostEdit->Modified = false;
   ProxyPortEdit->Text = smtp->Values["ProxyPort"]; ProxyPortEdit->Modified = false;
   ProxyPswdEdit->Text = smtp->Values["ProxyPswd"]; ProxyPswdEdit->Modified = false;
   ProxyUserEdit->Text = smtp->Values["ProxyUser"]; ProxyUserEdit->Modified = false;
   ProxyTORBox->Checked = smtp->Values["ProxyTOR"]; proxytororg = ProxyTORBox->Checked;
   AnsiString socksver = smtp->Values["ProxySocks"];
   if (socksver == "4" || socksver == "4a" || socksver == "5")
      ProxySocksVer->ItemIndex = ProxySocksVer->Items->IndexOf(socksver);
   socksverorg = ProxySocksVer->Text;
   delete smtp;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPProxyDlg::StoreProxy()
{
   TStringList *smtp = new TStringList();
   GetAppData(smtp,HttpInfo);
   smtp->Values["ProxyHost"] = ProxyHostEdit->Text;
   smtp->Values["ProxyPort"] = ProxyPortEdit->Text;
   smtp->Values["ProxyPswd"] = ProxyPswdEdit->Text;
   smtp->Values["ProxyUser"] = ProxyUserEdit->Text;
   smtp->Values["ProxySocks"] = ProxySocksVer->Text;
   smtp->Values["ProxyTOR"]  =  ProxyTORBox->Checked ? "1" : "0";
   PutAppData("smtpproxy", smtp);
   delete smtp;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPProxyDlg::ProxyPswdBoxClick(TObject *Sender)
{
   ProxyPswdEdit->PasswordChar = ProxyPswdBox->Checked ? '*':'\0';
}
//---------------------------------------------------------------------------
