/*
*  TBUFFER.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef TBUFFERH
#define TBUFFERH

#include "global.h"
//---------------------------------------------------------------------------

class TBUFFER : public TMemoryStream
{
   void  __fastcall SetPosition(long pos);
   long  __fastcall GetPosition();
   BYTE* __fastcall GetMemory();
   long  __fastcall GetSize();
public:
   AnsiString filename;
   // construct and destruct
   virtual __fastcall TBUFFER();
   virtual __fastcall TBUFFER(AnsiString Filename);
   virtual __fastcall~TBUFFER();
   // properties
   __property long ptr              = { read=GetPosition, write=SetPosition };
   __property BYTE *data            = { read=GetMemory }; // points to data as byte*
   __property char *chrs            = { read=GetMemory }; // points to data as char*
   __property long length           = { read=GetSize };
   // methods
   void __fastcall rewind();
   void __fastcall clear();
   bool __fastcall save();
   // convenience
   virtual BYTE __fastcall readbyte();
   virtual int  __fastcall readint();
   virtual long __fastcall readlong();
   virtual int  __fastcall writebyte(byte b);
   virtual int  __fastcall writeint(int i);
   virtual int  __fastcall writelong(long l);

   virtual byte __fastcall ReadByte();
   virtual int  __fastcall ReadInt();
   virtual long __fastcall ReadLong();
   virtual int  __fastcall WriteByte(byte b);
   virtual int  __fastcall WriteInt(int i);
   virtual int  __fastcall WriteLong(long l);
};
//---------------------------------------------------------------------------
#endif
