/*
*  UPDFtpDlg.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef UPDFtpDlgH
#define UPDFtpDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include "Ftpcli.hpp"
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall GetQSUpdateList(TComponent *Owner, TStrings *Commands, TStrings *Proxy, TStrings *FileList);
bool __fastcall GetQSUpdate(TComponent *Owner, TStrings *Commands, TStrings *Proxy);

class TUPDftpDlg : public TForm
{
__published:	// IDE-managed Components
  TLabel *Label1;
  TPanel *Panel1;
  TMemo *Display;
  TTimer *TimeOut;
  TFtpClient *FTP;
  TButton *CancelBtn;
  TProgressBar *ProgressBar1;
  void __fastcall FTPDisplay(TObject *Sender, AnsiString &Msg);
  void __fastcall FTPRequestDone(TObject *Sender, TFtpRequest RqType,WORD Error);
  void __fastcall FTPProgress(TObject *Sender, long Count, bool &Abort);
  void __fastcall FTPSessionConnected(TObject *Sender, WORD Error);
  void __fastcall FTPSessionClosed(TObject *Sender, WORD Error);
  void __fastcall CancelBtnClick(TObject *Sender);
  void __fastcall TimeOutTimer(TObject *Sender);
private:	// User declarations
public:		// User declarations
  int Filesize;
  WORD LastError;
  bool Cancel,Finished;
  AnsiString proxyname;
  double BytesTotal,BytesReceived;
  virtual __fastcall TUPDftpDlg(TComponent* Owner);
  virtual __fastcall TUPDftpDlg(TComponent* Owner, TStrings *FTPInfo, TStrings *Proxy);
  void __fastcall ParseFileList(TStringList *Results);
  int __fastcall GetUpdateList();
  int __fastcall GetUpdate();
};

//---------------------------------------------------------------------------
extern TUPDftpDlg *UPDftpDlg;
//---------------------------------------------------------------------------
#endif
