/*
*  pgpfiles.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef PgpFilesH
#define PgpFilesH
#include "mixmaster.h"
#include "global.h"
//---------------------------------------------------------------------------
AnsiString __fastcall PgpDir();
AnsiString __fastcall PgpPublicRing();
AnsiString __fastcall PgpSecretRing();
AnsiString __fastcall PgpImportRing();
AnsiString __fastcall PgpRemailRing();
AnsiString __fastcall PgpPubTmpRing(); // for both personal and remailer keys

bool __fastcall IsPGPArmoredHead(AnsiString line);                   // for parsing
bool __fastcall IsPGPArmoredTail(AnsiString line);                   // multi-block
bool __fastcall GetNextPGPArmored(BUFFER *asckeys, BUFFER *armored); // files
bool __fastcall GetNextPGPArmored(TStrings *asckeys, TStrings *armored);// files
int  __fastcall BeginPgpPubKeyBlockCount(TStrings *block);

void __fastcall FixPgpBeginEndLines(TStrings *lines);
const AnsiString BeginPgpPubKeyBlock = "-----BEGIN PGP PUBLIC KEY BLOCK-----";
const AnsiString EndPgpPubKeyBlock = "-----END PGP PUBLIC KEY BLOCK-----";
const AnsiString BeginPgpPriKeyBlock = "-----BEGIN PGP PRIVATE KEY BLOCK-----";
const AnsiString EndPgpPriKeyBlock = "-----END PGP PRIVATE KEY BLOCK-----";
const AnsiString BeginPgpSecKeyBlock = "-----BEGIN PGP SECRET KEY BLOCK-----";
const AnsiString EndPgpSecKeyBlock = "-----END PGP SECRET KEY BLOCK-----";
const AnsiString BeginPgpMessage = "-----BEGIN PGP MESSAGE-----";
const AnsiString EndPgpMessage = "-----END PGP MESSAGE-----";
const AnsiString BeginPgpSignedMessage = "-----BEGIN PGP SIGNED MESSAGE-----";
const AnsiString BeginPgpSignature = "-----BEGIN PGP SIGNATURE-----";
const AnsiString EndPgpSignature = "-----END PGP SIGNATURE-----";

const AnsiString IsConventionalEncr = "IsConventionalEncr";
#endif
